From 9d703800365277bc63f53a8570880d15ee8512ea Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Apr 06 2017 23:29:35 +0000
Subject: [PATCH 4/9] Documentation


---

diff --git a/docs/conf.py b/docs/conf.py
index 9264743..30c5281 100644
--- a/docs/conf.py
+++ b/docs/conf.py
@@ -34,6 +34,7 @@ extensions = [
     'sphinx.ext.doctest',
     'sphinx.ext.napoleon',
     'sphinx.ext.viewcode',
+    'sphinx.ext.todo',
 ]
 
 # Add any paths that contain templates here, relative to this directory.
@@ -116,7 +117,7 @@ pygments_style = 'sphinx'
 # keep_warnings = False
 
 # If true, `todo` and `todoList` produce output, else they produce nothing.
-todo_include_todos = False
+todo_include_todos = True
 
 
 # -- Options for HTML output ----------------------------------------------
diff --git a/hubs/authz.py b/hubs/authz.py
index ebd85ca..b38a150 100644
--- a/hubs/authz.py
+++ b/hubs/authz.py
@@ -1,21 +1,44 @@
+"""
+The authorization model is based on an access level hierarchy: each level
+grants more permissions than the previous level. The levels are represented by
+the :py:class:`AccessLevel` enum. For example they can be ``anonymous``,
+``logged_in``, ``member``, ``admin``... anything really, as long as there is a
+hierarchy.
+
+Permissions are named, for example ``view`` or ``edit``. Those permissions are
+linked to the corresponding access level using the :py:data:`PERMISSIONS`
+dictionary.  For example the ``view`` permission can be granted to
+``anonymous`` users, or to ``members`` only.
+
+Object instances where authorization applies can use the
+:py:class:`ObjectAuthzMixin` mixin which provides a method to check for
+permissions.  Those objects must implement a method in the mixin, see the class
+documentation for details.
+
+Todo:
+    Make a Flask extension that can be reused in other applications.
+    The :py:class:`AccessLevel` enum and the :py:data:`PERMISSIONS` mapping
+    will be configurable to suit the app's specifics.  There will be
+    separate backends for getting the user roles that can be chosen by
+    configuration.  The CAIAPI backend will be included.
+
+Attributes:
+    PERMISSIONS (dict): Mapping of permission names (string) to permission
+        level (:py:class:`AccessLevel` member).
+"""
+
 from __future__ import absolute_import, unicode_literals
 
 from enum import IntEnum
 from flask import current_app
 
 
-#class Authorization(object):
-#
-#    def __init__(self, app=None, db=None):
-#        self.db = db
-#        if app is not None:
-#            self.init_app(app)
-#
-#    def init_app(self):
-#        app.config.setdefault("AUTHZ_ADAPTER", None)
-
-
 class AccessLevel(IntEnum):
+    """Possible levels of access for a resource.
+
+    We use an ``IntEnum`` because there is a hierarchy in access level.
+    The ``IntEnum`` class make it easy because it is a subclass of integer.
+    """
     anonymous = 0
     logged_in = 1
     member = 2
@@ -35,8 +58,19 @@ PERMISSIONS = {
 
 
 class ObjectAuthzMixin(object):
+    """Make a model class authorization-aware.
+
+    This mixin introduces the :py:meth:`allows` method, which can be used to
+    check if a user has a permission.
+    """
 
     def allows(self, user, action):
+        """Check whether a user has the right to do the given action.
+
+        Args:
+            user (hubs.models.User): a User instance.
+            action (str): an action, which will be translated to a permission.
+        """
         site_admins = current_app.config.get("SITE_ADMINS", [])
         if user is not None and user.username in site_admins:
             return True
@@ -48,6 +82,19 @@ class ObjectAuthzMixin(object):
         return False
 
     def _get_auth_access_level(self, user):
+        """Get a user's access level.
+
+        A user's access level can come from its own properties (being logged-in
+        for example, or its username) and from its group roles. The global
+        access level is the highest access of the two.
+
+        Args:
+            user (hubs.models.User): a User instance.
+
+        Returns:
+            int: the member of :py:class:`AccessLevel` representing this user's
+                access level.
+        """
         if user is None:
             return AccessLevel.anonymous
         levels = [
@@ -57,9 +104,28 @@ class ObjectAuthzMixin(object):
         return max(l for l in levels if l is not None)
 
     def _get_auth_user_access_level(self, user):
+        """Get a user's access level based on its own properties.
+
+        Args:
+            user (hubs.models.User): a User instance.
+
+        Returns:
+            int: the member of :py:class:`AccessLevel` representing this user's
+                access level.
+        """
         return AccessLevel.logged_in
 
     def _get_auth_group_access_level(self, user):
+        """Get a user's access level based on its group roles.
+
+        Args:
+            user (hubs.models.User): a User instance.
+
+        Returns:
+            int: the member of :py:class:`AccessLevel` representing this user's
+                access level or ``None`` if no access level can be derived from
+                group roles.
+        """
         group = self._get_auth_group()
         user_roles = self._get_auth_user_roles(user)
         try:
@@ -74,15 +140,36 @@ class ObjectAuthzMixin(object):
             return None
 
     def _get_auth_group(self):
+        """Get the corresponding authentication backend's group.
+
+        For each object using this mixin, there can be a group in the
+        authentication backend that will control access to this resource.
+        Roles in this group can be mapped to AccessLevels in this app.
+        """
         raise NotImplementedError
 
     def _get_auth_user_roles(self, user):
-        return get_user_roles(user)
+        """Get all the roles for a user.
+
+        Args:
+            user (hubs.models.User): a User instance.
+
+        Returns:
+            dict: the mapping of group names (str) to roles (str) in the
+                authentication backend for this user.
+
+        Todo:
+            Use the new CAIAPI when it is ready.
+        """
+        return {g: "member" for g in user.groups}
 
     def _get_auth_permission_name(self, action):
-        return action
+        """Return the permission name for the given action.
 
+        Args:
+            action (str): an action name
 
-def get_user_roles(user):
-    # TODO: use the new API
-    return {g: "member" for g in user.groups}
+        Returns:
+            str: a key in the :py:data:`PERMISSIONS` dictionary.
+        """
+        return action
diff --git a/hubs/views/utils.py b/hubs/views/utils.py
index 15ee71a..1821026 100644
--- a/hubs/views/utils.py
+++ b/hubs/views/utils.py
@@ -1,3 +1,8 @@
+"""
+The :py:mod:`hubs.views.utils` module contains helper functions and classes
+for the views.
+"""
+
 from __future__ import unicode_literals
 
 import datetime

